<?php
$groups;
$power;
$default_perms;
$Mod_perms;
$Admin_perms;
$Dev_perms;
$Owner_perms;
function setUp()
{
    global $groups;
    $groups = array(
        array("default", 0, "Database/index.php", "vault.php", "load_database.php"),
        array("Mod", 1),
        array("Admin", 2, "Admin/index.php"),
        array("Dev", 3),
        array("Owner", 4, "*")
    ); //these are the groups with their power and permissions.
    //Format: array("GROUP_NAME", POWER (INHERITANCE), "PERMS1...", "PERMS2...", "PERMS3")
}

function getGroups()
{
    global $groups;
    $res = "";
    foreach($groups as $key => $value)
    {
        
        $pow = getPower($groups[$key][0]);
        $perms = getPerms($groups[$key][0]);
        $res = $res . "<br>{$groups[$key][0]}<br> power: {$pow}<br>Perms {<br>{$perms}}<br>";
        
    }
    return $res;
    
    
    
}
function getNumPerms($pow)
{
    global $groups;
    $res = "";
    foreach($groups as $key => $value)
    {
        if($groups[$key][1] == $pow)
        {
            $grp = $groups[$key];
            foreach($grp as $key2 => $value2)
            {
                if($key2 != 0 && $key2 != 1)
                {
                    $r = $grp[$key2];
                    $res .= $r . "|";
                }
            }
        }
    }
    return $res;
}

function getPerms($group)
{
    global $groups;
    $res = "";
    $perms_group = "";
    foreach($groups as $key => $value)
    {
        if($groups[$key][0] == $group)
        {
            $grp = $groups[$key];
            $res .= "";
            foreach($grp as $key2 => $value2)
            {
                if($key2 != 0 && $key2 != 1)
                {
                    $res .= "{$grp[$key2]}<br>";
                }
            }
        }
    }
    return $res;
}

function getPower($group)
{
    global $groups;
    $pow = 0;
    foreach($groups as $key => $value)
    {
        if($groups[$key][0] == $group) $pow = $groups[$key][1];
    }
    return $pow;
}

function getUserGroup($user)
{
    
    $group = $_SESSION["rank"];
    return $group;
}

function hasPerm($group, $perm)
{
    global $groups;
    $res = false;
    $pow;
    $times = 0;
    $perms_arr = array("nan");
    foreach($groups as $key => $value)
    {
        if($groups[$key][0] == $group)
        {
            $pow = $groups[$key][1];
        }
    }
    
    $pow_arr = array(0);
    $times = $pow;
    while($times >= 0)
    {
        array_push($pow_arr, $times);
        $times = $times-1;
    }
    foreach($pow_arr as $key3 => $value3)
    {
        $num = $pow_arr[$key3];
        $ar = getNumPerms($num);
        while(strpos($ar, "|") != false)
        {
            $st = substr($ar, 0, strpos($ar, "|"));
            array_push($perms_arr, $st);
            $ar = substr($ar, (strpos($ar, "|")+1));

        }
        
    }
    $perms_arr = array_unique($perms_arr);

    foreach($perms_arr as $key2 => $value2)
    {
        $permz = $perms_arr[$key2];
        if($permz == $perm || $permz == "*") $res = true;
    }
    return $res;
}
function oldhasPerm($group, $perm)
{

    global $groups;
    $res2 = false;
    $pow;
    $grp;
    $str = true;
    $perms_arr = array(" ", " ");
    foreach($groups as $key => $value)
    {
        if($groups[$key][0] == $group)
        {
            $grp = $groups[$key];
            foreach($groups as $key3 => $value3)
            {
                $grb = $groups[$key3];
                if($grb == $grp) 
                {
                    $str = false;
                    foreach($grb as $key4 => $value4)
                    {
                        if($key4 != 0 && $key4 != 1)
                        {
                            array_push($perms_arr, $grb[$key4]);
                        }
                    }
                }
                else if($str) {

                    foreach($grb as $key4 => $value4)
                    {
                        if($key4 != 0 && $key4 != 1)
                        {
                            array_push($perms_arr, $grb[$key4]);
                        }
                    }
                    
                }
            }
            
        }
    }
    foreach($perms_arr as $key5 => $value5)
    {
        $permz = $perms_arr[$key5];
        if(($permz == $perm || $permz == "*") && $key5 != 0 && $key5 != 1) $res2 = true;
    }
    return $res2;
}

?>